<template>
  <transition enter-active-class="jw-toast--fade-in-down" leave-active-class="jw-toast--fade-out">
    <div v-show="isActive" class="jw-toast__item-wrapper flex justify-center">
      <div
        class="jw-toast__item"
        :class="`jw-toast__item--${type}`"
        @mouseover="toggleTimer(true)"
        @mouseleave="toggleTimer(false)"
        @click="onToastItemClicked"
      >
        <p class="flex items-center">
          <span v-if="iconToShow" class="mr-2 flex-none">
            <img class="h-5 w-5 md:h-6 md:w-6" :src="iconToShow" alt="icon" />
          </span>
          <span class="text-center" v-html="message"></span>
        </p>
      </div>
    </div>
  </transition>
</template>

<script>
import eventBus from './eventBus';
import Timer from './timer';
import './styles.css';

export default {
  props: {
    message: {
      type: String,
      required: true,
    },
    type: {
      type: String,
      required: true,
    },
    icon: {
      type: [String, null],
      default: null,
    },
    duration: {
      type: Number,
      default: 4000,
    },
    maxNumberToShow: {
      type: Number,
      default: 6,
    },
    closeOnMouseLeave: {
      type: Boolean,
      default: true,
    },
    closable: {
      type: Boolean,
      default: true,
    },
  },
  data: () => ({
    parentTopContainer: null,
    isActive: false,
    isHovered: false,
  }),
  computed: {
    iconToShow() {
      if (this.icon) {
        return this.icon;
      }
      switch (this.type) {
        case 'success':
          return require('~/plugins/jw-toast/icons/success.svg');
        case 'error':
          return require('~/plugins/jw-toast/icons/error.svg');
        case 'warning':
          return require('~/plugins/jw-toast/icons/warning.svg');
        default:
          return null;
      }
    },
  },
  beforeMount() {
    this.setupContainer();
  },
  mounted() {
    this.showNotice();
    eventBus.$on('toast-clear', this.dismiss);
  },
  beforeDestroy() {
    eventBus.$off('toast-clear', this.dismiss);
  },
  methods: {
    setupContainer() {
      this.parentTopContainer = document.querySelector('.jw-toast');
      if (this.parentTopContainer) {
        return;
      }
      if (!this.parentTopContainer) {
        this.parentTopContainer = document.createElement('div');
        this.parentTopContainer.className = 'jw-toast';
      }
      const container = document.body;
      container.appendChild(this.parentTopContainer);
    },
    showNotice() {
      if (this.maxNumberToShow === this.parentTopContainer.childElementCount) {
        this.parentTopContainer.removeChild(this.parentTopContainer.lastChild);
      }
      this.parentTopContainer.insertAdjacentElement('afterbegin', this.$el);
      this.isActive = true;
      this.timer = new Timer(this.dismiss, this.duration);
    },
    dismiss() {
      if (this.timer) {
        this.timer.stop();
      }
      this.isActive = false;
      setTimeout(() => {
        this.$destroy();
        this.removeElement(this.$el);
      }, 150);
    },
    removeElement(el) {
      if (typeof el.remove !== 'undefined') {
        el.remove();
      } else {
        el.parentNode.removeChild(el);
      }
    },
    toggleTimer(newVal) {
      if (!this.timer || !this.closeOnMouseLeave) {
        return;
      }
      newVal ? this.timer.pause() : this.timer.resume();
    },
    onToastItemClicked() {
      if (this.closable) {
        this.dismiss();
      }
    },
  },
};
</script>
